Subject: Re: FVWM: Possible bug in WinListFunc (and a suggestion... :-)

From: Dominik Vogt <[email-masked]>
Date: Tue, 12 Jan 1999 19:08:28 +0100

On Mon, Jan 11, 1999 at 12:19:21AM +0200, Kobus Retief wrote:
> Hi
> 
> 
> The (possible) bug:
> 
> I'm currently running fvwm 2.1.7 on a (slightly modified)
> Slackware Linux (kernel 2.2.0pre6, XFree86 3.3.3) system.
> I've modified the WinListFunc as follows in my .fvwm2rc:
> 
> DestroyFunc WindowListFunc
> AddToFunc WindowListFunc
> + "I"	WindowId $0 FlipFocus
> + "I"	WindowId $0 Raise
> + "I"	WindowId $0 WarpToWindow 0 0
> + "I"	WindowId $0 WarpToWindow 50 50
> 
> When I select a window from the WindowList builtin, everything
> happens as planned (top left corner of window in top left corner
> of screen, cursor in middle of window), but fvwm gives me the
> window selection cursor (the one you get when [for instance] you 
> tell fvwm to "maximize" and then have to select a window), and waits
> for me to click before focusing the window.  This obviously shouldn't
> happen, as I've stepped through this function using FvwmTalk, and
> everything worked perfectly.
> 
> I don't _remember_ having this problem under fvwm 2.1.5 (with the same
> .fvwm2rc, except for adding the new MenuStyle builtin).

But I'm sure you had. This was already in 2.0.46 and probably a
lot versions before that. The problem is that WindowId needs a
window to operate on and then ignores it completely.

To the folks on the workers list:

The problem lies in parse.h. WindowId is listed in the section with
functions that need a window. As are lots of other functions I don't
believe that should be there:

    F_SEND_STRING,
    F_ADD_MOD,
    F_DESTROY_MOD,
    F_ECHO,
    F_BORDERSTYLE,
    F_WINDOWID,
    F_ADD_BUTTON_STYLE,
    F_ADD_TITLE_STYLE,
    F_ADD_DECOR,
    F_DESTROY_DECOR,
    F_UPDATE_DECOR,
    F_COLOR_LIMIT,

At least these functions have the FUNC_NO_WINDOW attribute set in functions.c.
I think we shouldn't use column 3 in the functions table to check if a
function needs a window at all. Colums four should suffice. The big question
is: will fvwm continue to work if I change that now (complec.c)?

Bye

Dominik

--
Dominik Vogt, [email-masked]
Reply-To: [email-masked]

--
Visit the official FVWM web page at <URL:http://www.hpc.uh.edu/fvwm/>.
To unsubscribe from the list, send "unsubscribe fvwm-workers" in the
body of a message to [email-masked].
To report problems, send mail to [email-masked].